// Copyright (c)2002 Eric Carlson
// This source is licensed under the BSD license.
// Please see the LICENSE.txt file included with the distribution for more information.

#include <Carbon/Carbon.h>

//for id and SEL types
#include <objc/objc.h>

//for sleep()
#include <unistd.h>

//struct of information passed to notification callback
//this contains the information necessary to call the Objective-C
//selector in the controller from C as a method
typedef struct OurDMNotifyData
{
    //the class the update method is in
    id updateMethodSelf;
    //the selector that is the update method
    SEL updateMethodSelector;
    //the function pointer that gets called with the necessary
    //Objective-C state information as defined in the documentation
    void (*updateMethod)(id, SEL); //update method to call (objective C)
} OurDMNotifyData, *OurDMNotifyDataPtr, **OurDMNotifyDataHdl;

void registerNotification(OurDMNotifyDataPtr dataP);
void notificationCallback (void *userData, SInt16 theMessage, void *notifyData);
void removeNotification(OurDMNotifyDataPtr dataP);